步骤
---
   + 自己实现pc.c,然后复制到linux0.11中使用
   + 自行编写sem.c, 修改markfile编译进去
   + sem.c里面用了一个`sem_t`的数据结构，需要在`unistd.h`里面定义


Answers:
--
1. 在pc.c中去掉所有信号量有关的代码，再运行程序，执行效果会有变化吗? 为什么会这样呢？  
有变化，输出的结果没有顺序，程序会产生奔溃。
没有了信号量，进程之间无法进行同步或者协作，一种情况下是缓冲区满了，生产者还在写入数据；一种是缓冲区没了，消费者还在消费数据。

2. 2.实验的设计者在第一次编写生产者——消费者程序的时候，是这么做的：
```c
 Producer()
 {
     P(Mutex); //互斥信号量
     生产一个产品item;
     P(Empty); //空闲缓存资源
     将item放到空闲缓存中;
     V(Full); //产品资源
     V(Mutex);
 }

 Consumer()
 {
     P(Mutex);  
     P(Full);  
     从缓存区取出一个赋值给item;
     V(Empty);
     消费产品item;
     V(Mutex);
 } 
 ```
 这样可行吗？如果可行，那么它和标准解法在执行效果上会有什么不同？如果不可行，那么它有什么问题使它不可行？   
这样做是可不行的。只有当缓冲区可写或者可读的时候，才能锁定临界资源。
比如缓冲区锁定的时候empty=10,full=0，这样的话就会出现死锁状态。